import 'dart:io';

class Version {
  static const allowed = ["git"];
  static const defaultsTo = "git";
  DateTime datetime;
  String tag;
  String commit;
  Version({this.tag, this.commit, this.datetime})
      : assert(datetime != null),
        assert(tag != null),
        assert(commit != null);
  Version.fromControl(String control) {
    switch (control) {
      case "git":
        _fromGit();
        break;
      default:
        throw UnsupportedError("not support version control :$control");
    }
  }
  _fromGit() {
    var result = Process.runSync("git", ["describe"]);
    tag = result.stdout.toString().trim();

    result = Process.runSync("git", ["rev-parse", "HEAD"]);
    commit = result.stdout.toString().trim();

    datetime = DateTime.now();
  }
}
